#!/bin/sh
set -e
. ../../../define/FUNCTION_SCRIPT
friendlyName="Wireless Router"
if [ "${_SMARTWAYS_}" = "y" ]; then
	manufacturer=""
else
	manufacturer="$_MODE_"
fi
manufacturerURL=""
modelDescription=""
modelName=""
modelNumber=""
modelURL=""
if [ "$_MODE_" = "Customer" ]; then
	manufacturer="Customer Technology Co. Ltd"
	modelName="300Mbps Wireless Router"
	modelNumber="BR-6428nS"
elif [ "$_MODE_" = "Customer" ]; then
	manufacturer="Customer"
	modelName="Wireless 300N Router"
	modelNumber="HAWNR3"
elif [ "$_MODE_" = "Customer" -a "$_MODEL_" = "BR6258GNL" ]; then
        manufacturer="General"
        modelName="BR6258GNL"
        modelNumber="BR6258GNL"
elif [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6428HPN" ]; then #EDX yihong
	manufacturer="Customer Technology Co., Ltd"
        modelName="N300 High Power Wireless Broadband Router"
	modelNumber="BR-6428HPN"
elif [ "$_MODE_" = "Customer" ]; then  #PATRICK
	manufacturer="Customer Technology Co., Ltd"
	modelName="Wireless Router"
	modelNumber="BR-6428HPN" #PATRICK
elif [ "$_MODE_" = "Customer" ]; then   #Leo
        manufacturer="SMARTLINK"
        manufacturerURL="http://www.digisol.com"
        modelNumber="DG-BR1000Nu"        #Leo
fi
echo "<?xml version=\"1.0\" ?> 
 <root xmlns=\"urn:schemas-upnp-org:device-1-0\">
 <specVersion>
  <major>1</major> 
  <minor>0</minor> 
  </specVersion>
 <device>
  <deviceType>urn:schemas-upnp-org:device:InternetGatewayDevice:1</deviceType> 
  <friendlyName>$friendlyName</friendlyName> 
  <manufacturer>$manufacturer</manufacturer> 
  <manufacturerURL>$manufacturerURL</manufacturerURL> 
  <modelDescription>$modelDescription</modelDescription>  
  <modelName>$modelName</modelName> 
  <modelNumber>$modelNumber</modelNumber>
  <modelURL>$modelURL</modelURL> 
  <UDN>uuid:12342409-1234-1234-5678-ee1234cc5678</UDN> 
 <serviceList>
 <service>
  <serviceType>urn:schemas-dummy-com:service:Dummy:1</serviceType> 
  <serviceId>urn:dummy-com:serviceId:dummy1</serviceId> 
  <controlURL>/dummy</controlURL> 
  <eventSubURL>/dummy</eventSubURL> 
  <SCPDURL>/dummy.xml</SCPDURL> 
  </service>
  </serviceList>
 <deviceList>
 <device>
  <deviceType>urn:schemas-upnp-org:device:WANDevice:1</deviceType> 
  <friendlyName>WANDevice</friendlyName> 
  <manufacturer>Wireless Router</manufacturer> 
  <manufacturerURL></manufacturerURL> 
  <modelDescription>WANCommonInterfaceConfig</modelDescription> 
  <modelName>WANCommonInterfaceConfig</modelName> 
  <modelNumber>1</modelNumber> 
  <modelURL></modelURL> 
  <serialNumber>00000000</serialNumber> 
  <UDN>uuid:12342409-1234-1234-5678-ee1234cc5678</UDN> 
  <UPC>MINIUPNPD</UPC> 
 <serviceList>
 <service>
  <serviceType>urn:schemas-upnp-org:service:WANCommonInterfaceConfig:1</serviceType> 
  <serviceId>urn:upnp-org:serviceId:WANCommonIFC1</serviceId> 
  <controlURL>/upnp/control/WANCommonInterfaceConfig</controlURL> 
  <eventSubURL>/upnp/event/WANCommonInterfaceConfig</eventSubURL> 
  <SCPDURL>/wancfg.xml</SCPDURL> 
  </service>
  </serviceList>
 <deviceList>
 <device>
  <deviceType>urn:schemas-upnp-org:device:WANConnectionDevice:1</deviceType> 
  <friendlyName>WANConnectionDevice</friendlyName> 
  <manufacturer>Wireless Router</manufacturer> 
  <manufacturerURL></manufacturerURL> 
  <modelDescription>WANConnectionDevice</modelDescription> 
  <modelName>WANConnectionDevice</modelName> 
  <modelNumber>1</modelNumber> 
  <modelURL></modelURL> 
  <serialNumber>00000000</serialNumber> 
  <UDN>uuid:12342409-1234-1234-5678-ee1234cc5679</UDN> 
  <UPC>MINIUPNPD</UPC> 
 <serviceList>
 <service>
  <serviceType>urn:schemas-upnp-org:service:WANIPConnection:1</serviceType> 
  <serviceId>urn:upnp-org:serviceId:WANIPConn1</serviceId> 
  <controlURL>/upnp/control/WANIPConnection</controlURL> 
  <eventSubURL>/upnp/event/WANIPConnection</eventSubURL> 
  <SCPDURL>/wanipcn.xml</SCPDURL> 
  </service>
  </serviceList>
  </device>
  </deviceList>
  </device>
  </deviceList>
  <presentationURL>http://!ADDR!/</presentationURL> 
  </device>
  </root>" > picsdesc.skl
