#!/bin/sh
set -e
. ../../define/PATH
. ../../define/FUNCTION_SCRIPT
if [ -f Makefile ]; then
make distclean
fi
if [ "$1" = "clean" ]; then exit; fi
if [ "$_WanAutoDetect_" ] || [ "$_IQSETUP_" ] || [ "$_QUICK_MODE_TYPE_" ]; then
	CC=${CROSS_COMPILE}gcc CFLAGS="-Os -D_WanAutoDetect_" ./configure --host=mips-linux --prefix=/
else
	CC=${CROSS_COMPILE}gcc CFLAGS="-Os" ./configure --host=mips-linux --prefix=/
fi
if [ "$1" = "configure" ]; then exit; fi
make
${CROSS_COMPILE}strip src/dnrd
