#!/bin/sh
set -e
. ../../../../../define/PATH
export PATH=$CROSSDIR:$PATH
make distclean
if [ "$1" = "clean" ]; then exit; fi
CC=${CROSS_COMPILE}gcc CFLAGS=-Os LD=${CROSS_COMPILE}ld NM=${CROSS_COMPILE}nm AR=${CROSS_COMPILE}ar RANLIB=${CROSS_COMPILE}ranlib STRIP=${CROSS_COMPILE}strip OBJDUMP=${CROSS_COMPILE}objdump ./configure --build=i686 --host=mips-linux
exit
if [ "$1" = "configure" ]; then exit; fi
make KERNEL_DIR=${LINUXDIR} NO_SHARED_LIBS=1 DO_MULTI=0 CC=${CROSS_COMPILE}gcc AR=${CROSS_COMPILE}ar
${CROSS_COMPILE}strip .libs/iptables-static -o .libs/iptables
${CROSS_COMPILE}strip .libs/ip6tables-static -o .libs/ip6tables
