#!/bin/sh
if [ "$1" = "disable" ]; then exit; fi
. /web/FUNCTION_SCRIPT
eval `flash get APP_LAYER_GATEWAY`
if [ "$_MODE_" = "Airlive" ]; then
FTP=`echo $APP_LAYER_GATEWAY | grep -i FTP`
else
FTP=`echo $APP_LAYER_GATEWAY | grep FTP`
fi
H323=`echo $APP_LAYER_GATEWAY | grep h323`
IPSEC=`echo $APP_LAYER_GATEWAY | grep ipsec`
PPTP=`echo $APP_LAYER_GATEWAY| grep pptp`
L2TP=`echo $APP_LAYER_GATEWAY | grep l2tp`
SIP=`echo $APP_LAYER_GATEWAY | grep sip`
if [ "$FTP" = "" ]; then
iptables -I FORWARD -p TCP --dport 21 -j DROP
fi
if [ "$H323" = "" ]; then
iptables -I FORWARD -p TCP --dport 1720 -j DROP
iptables -I FORWARD -p TCP --dport 1731 -j DROP
fi
if [ "$IPSEC" = "" ]; then
iptables -I FORWARD -p UDP --dport 500 -j DROP
fi
if [ "$PPTP" = "" ]; then
iptables -I FORWARD -p TCP --dport 1723 -j DROP
fi
if [ "$L2TP" = "" ]; then
iptables -I FORWARD -p UDP --dport 1701 -j DROP
fi
if [ "$_KERNEL_VERSION_26_" != "y" ]; then
if [ "$SIP" = "" ]; then
echo 0 > /proc/sip_alg
else
echo 1 > /proc/sip_alg
fi
fi
if [ "$_MODE_" = "Airlive" ]; then
if [ "`echo $APP_LAYER_GATEWAY | grep igmp`" = "" ]; then
echo 0 > /proc/br_igmpProxy
echo 0 > /proc/br_igmpsnoop
else
echo 1 > /proc/br_igmpProxy
echo 1 > /proc/br_igmpsnoop
fi
fi
if [ "$_MODE_" = "Customer" ]; then
vpnpassthrough.sh
fi
if [ "$_PROC_SIP_ALG_" = "y" ]; then
if [ "`echo $APP_LAYER_GATEWAY | grep mundor`" = "" ]; then
echo 1 > /proc/sip_alg
else
echo 0 > /proc/sip_alg
fi
fi
