#!/bin/sh
if [ $# -lt 2 ]; then echo "Usage: $0 interface {wait|no]";  exit 1 ; fi
. /bin/scriptlib.sh
SCRIPT_PATH=/var/udhcpc
PIDFILE=/var/udhcpc/udhcpc-$1.pid
CMD="-i $1 -p $PIDFILE -s $SCRIPT_PATH/$1.sh"
if [ "$2" = 'no' ]; then
CMD="$CMD -n"
echo "#!/bin/sh" > $SCRIPT_PATH/$1.deconfig
echo "ifconfig $1 $IP_ADDR netmask $SUBNET_MASK" >> $SCRIPT_PATH/$1.deconfig
echo "while route del -net default gw 0.0.0.0 dev $1" >> $SCRIPT_PATH/$1.deconfig
echo "do :" >> $SCRIPT_PATH/$1.deconfig >> $SCRIPT_PATH/$1.deconfig
echo "done" >> $SCRIPT_PATH/$1.deconfig >> $SCRIPT_PATH/$1.deconfig
echo "route add -net default gw $DEFAULT_GATEWAY dev $1" >> $SCRIPT_PATH/$1.deconfig
else
echo "#!/bin/sh" > $SCRIPT_PATH/$1.deconfig
echo "ifconfig $1 0.0.0.0" >> $SCRIPT_PATH/$1.deconfig
fi
kill -9 `pidof udhcpc` 2> /dev/null
udhcpc $CMD
