#!/bin/sh
#include file
. /bin/scriptlib.sh
. /web/FUNCTION_SCRIPT	#cypress 100723
LOG_FILE=/var/log/security
L2TP_LOG=/var/log/l2tp.err
TMP_LOG=/var/tmp.log
MAX_LINE=1000
SAFE_LINE=900
SLEEP_TIME=10
ddnsUpdateTime=604800	#cypress 100714 edimax30
if [ "$_USB_8712_" = "y" ]; then
	RETRYTIME=0
fi
if [ "$_EDIMAX30_" = "y" ]; then
	ddnsUpdateTime2=10	#cypress 100714 edimax30
fi
# Parental Control
if [ "$_PARENTAL_CONTROL_" = "y" ]; then
	ParentalControlTimer=0
	ParentalControlMAC=`echo $PAR_CON_MAC | cut -b 1-2`:`echo $PAR_CON_MAC | cut -b 3-4`:`echo $PAR_CON_MAC | cut -b 5-6`:`echo $PAR_CON_MAC | cut -b 7-8`:`echo $PAR_CON_MAC | cut -b 9-10`:`echo $PAR_CON_MAC | cut -b 11-12`
fi
sntp_timer=0
min_time=0
x=0
y=0
if [ "$_TIME_ZONE_TYPE_" = "y" ]; then
	if [ "$TIME_TYPE" = 0 ];then
		sntp.sh &
	fi
else
	sntp.sh &
fi
killall watchdog.sh 2>/dev/null
if [ "$_WATCH_DOG_" = "y" ] && [ "$WATCH_DOG_ENABLE" = 1 ]; then
	watchdog.sh $WATCH_DOG_HOST $WATCH_DOG_INTERVAL &
fi
#kill `ps | grep '/bin/sh /bin/repeater_status.sh' | grep -v grep | cut -b-5`
if [ "$_REPEATER_STAT_" = "y" ] && [ "`ps | grep '/bin/sh /bin/repeater_status.sh' | grep -v grep`" = "" ]; then
	repeater_status.sh &
fi
#EDX yihong
if [ "$_AUTO_CHANNEL_DET_" = "y" ]; then
        kill -9 `ps | grep auto_chan_det.sh | grep -v grep | cut -b1-6 | tr -d " "` 2> /dev/null
        if [ "$OP_MODE" != "0" ] && [ "$STADRV_SSID" != "" ]; then
                /bin/auto_chan_det.sh &
        fi
fi
while [ true ]; do
	if [ $sntp_timer -ge 21600 ]; then
		if [ "$_TIME_ZONE_TYPE_" = "y" ]; then
			 if [ "$TIME_TYPE" = 0 ];then
				sntp.sh &
			 fi
		else
			sntp.sh &
		fi
		sntp_timer=0
	fi
	sntp_timer=`expr $sntp_timer + $SLEEP_TIME`
	RELOAD_PID=`ps -aux | grep reload | grep -v grep`
	if [ "$RELOAD_PID" = "" ]; then
		killall reload 2>/dev/null
		reload&
	fi
	if [ "$_IS_GATEWAY_" = "y" ]; then
		#ddns auto update ever week.
		ddnsUpdateTime=`expr $ddnsUpdateTime - 10`
		if [ "$ddnsUpdateTime" = 0 ]; then
			ddns.sh &
			ddnsUpdateTime=604800
		fi
		if [ -f $LOG_FILE ]; then
			LINES=`cat $LOG_FILE | wc -l`
			if [ "$LINES" -gt "$MAX_LINE" ]; then
				head -n $LINES $LOG_FILE | tail -n $SAFE_LINE > $TMP_LOG
				cp $TMP_LOG $LOG_FILE
				rm -f $TMP_LOG
			fi
		fi
		if [ -f $L2TP_LOG ]; then
			LINES=`cat $L2TP_LOG | wc -l`
			if [ "$LINES" -gt "$MAX_LINE" ]; then
				head -n $LINES $L2TP_LOG | tail -n $SAFE_LINE > $TMP_LOG
				cp $TMP_LOG $L2TP_LOG
				rm -f $TMP_LOG
			fi
		fi
		CHECK=0
		case "$WAN_MODE" in
		0)
			connect=`ifconfig $_WAN_IF_ | grep "inet addr" | grep -v grep`
			if [ "$connect" ]; then
			CHECK=1
			fi
			;;
			#	"1")
			#		CHECK=1
			#		;;
			1 | 2 | 3 | 6)
			#	    if [ -f /etc/ppp/link ]; then
			CHECK=1
			#		fi
			;;
		esac
		if [ "$_IPV6_SUPPORT_" = "y" ] && [ "$IPV6_WAN_MODE" != 0 ]; then
			if [ "`pidof dnsmasq`" = "" ]; then
				echo [`date +"%F %T"`]: [DNS]: dns restart ... >> /var/log/security
				ipv6_dns.sh
			fi
		else
			if [ "`pidof dnrd`" = "" -a "$DNS_MODE" = 0 ]; then
				
				# 因為軟測說只要有手動 DNS 就不能跑 DNRD，要用 udhcpd 發給底下的 client
				if [ "$_MODEL_" = "BR6428GN" ] && [ "$_MODE_" = "Hama" ]; then
					if [ "$DNS1" = '0.0.0.0' ] && [ "$DNS2" = '0.0.0.0' ] && [ "$DNS3" = '0.0.0.0' ]; then
						echo [`date +"%F %T"`]: [DNS]: dns restart ... >> /var/log/security
						dnrd.sh
					fi
				else
					echo [`date +"%F %T"`]: [DNS]: dns restart ... >> /var/log/security
					dnrd.sh
				fi
			fi
		fi
#EDX yihong		
		if [ "$_QUICK_MODE_TYPE_" = "y" ]; then
			why=0
			if [ -f /tmp/wscd_status ];then
			WPS_STATUS="`cat /tmp/wscd_status`"
			fi
			if [ "$WPS_STATUS" = "0" ];then
				min_time=0
				x=0
			fi
			if [ "$WPS_STATUS" = "3" ] && [ $min_time -lt 300 ];then
			min_time=`expr $min_time + $SLEEP_TIME`
			fi
			if [ "$why" = 0 ] && [ "`fping 8.8.8.8 | grep alive | wc -l`" = 1 ];then # Google DNS	
				why=1	
				if [ "$y" = "0" ];then	
					x=0
				elif [ "$y" = "1" ] && [ $min_time -gt 290 ] && [ $min_time -lt 390 ];then
					x=0
					min_time=400
				fi
				y=1
			else
				why=0	
				if [ "$y" = "1" ];then	
					x=0
				elif [ "$y" = "0" ] && [ $min_time -gt 290 ] && [ $min_time -lt 390 ];then
					x=0
					min_time=400
				fi
				y=0	
			fi
       	if [ "$why" = 1 ]; then
				if [ "`pidof wps.sh`" = "" ]; then
					if [ "$WPS_STATUS" = "3" ] && [ $min_time -lt 290 ];then
						if [ "$x" = "0" ];then	
							echo 0 > /proc/wps_led
							x=1
						fi
					else
						if [ "$x" = "0" ];then					
							echo 3 > /proc/wps_led
							if [ "$_INTERNET_STATE_" = "y" ]; then
								echo 0 > /proc/internet_led
							fi
							x=1
						fi
					fi
				fi
				iptables -t nat -D PREROUTING -i br0 ! -d $IP_ADDR --proto tcp --dport 80 -j DNAT --to $IP_ADDR:8000
				if [ "`pidof httpd`" != "" ]; then
             echo 1 > /tmp/wanStatus
				kill -9 `pidof httpd` 2>/dev/null
				iptables -t nat -D PREROUTING -i br0 ! -d $IP_ADDR --proto tcp --dport 80 -j DNAT --to $IP_ADDR:8000
				fi
			else	
				if [ "`pidof wps.sh`" = "" ]; then
					if [ "$WPS_STATUS" = "3" ] && [ $min_time -lt 290 ];then
						if [ "$x" = "0" ];then				
							echo 0 > /proc/wps_led		
							x=1
						fi	
					else
						if [ "$x" = "0" ];then	
							echo 3 > /proc/wps_led
							if [ "$_INTERNET_STATE_" = "y" ]; then
								echo 1 > /proc/internet_led		
							fi
							x=1
						fi	
					fi
				fi
				if [ "`pidof httpd`" = "" ]; then
             echo 2 > /tmp/wanStatus
				httpd -h /tmp/www -p 8000
				iptables -t nat -D PREROUTING -i br0 ! -d $IP_ADDR --proto tcp --dport 80 -j DNAT --to $IP_ADDR:8000
				iptables -t nat -I PREROUTING -i br0 ! -d $IP_ADDR --proto tcp --dport 80 -j DNAT --to $IP_ADDR:8000
				kill -SIGUSR2 `pidof dnrd`
        		fi
			fi
		fi
	fi
	if [ "$_EDIMAX30_" = "y" ]; then
		ddnsUpdateTime2=`expr $ddnsUpdateTime2 - $SLEEP_TIME`
		if [ "$ddnsUpdateTime2" -le 0 ]; then
			ddns_update &
			ddnsUpdateTime2=600
		fi
	fi
	if [ "`pidof webs`" = "" ]; then
		webs&
	fi
	if [ "$_DISPLAY_SIGNAL_STRENGTH_" = "y" ] && [ "$AP_MODE" = 6 -o "$AP_MODE" = 2 ]; then
		#signal_strength.sh &
		tmp_sig_str="`iwpriv wlan0 signal_strength | cut -f 2 -d :`"
		if [ "$tmp_sig_str" -ge 50 ]; then
			echo LED ON > /dev/WLAN_LED0
		elif [ "$tmp_sig_str" -eq -1 ]; then
			echo LED OFF > /dev/WLAN_LED0
		else
			echo LED BLINK 65535 > /dev/WLAN_LED0
		fi
		echo "Signal Strength = "$tmp_sig_str
	fi
	if [ "$_WAN_DHCP_AUTO_RELEASED_" = "y" ] && [ -f "/var/dhcpCheck.var" ]; then
		if [ `cat /var/dhcpCheck.var` = "start" ]; then
			checkWANStatus
		fi
	fi
	# Parental Control
	if [ "$_PARENTAL_CONTROL_" = "y" ]; then
		if [ "$PAR_CON_ENABLED" = 1 ]; then
			if [ "$ParentalControlTimer" = 0 ]; then
				ParentalControlTimer=30
				ParentalControlCheck=`cat /proc/net/arp | grep -i $ParentalControlMAC`
				if [ "$ParentalControlCheck" ]; then
					iptables -D FORWARD -i br0 -j DROP > /dev/null 2>&1
					ping -c 1 `echo $ParentalControlCheck | cut -d " " -f 1` > /dev/null 2>&1 &
				else
					iptables -D FORWARD -i br0 -j DROP > /dev/null 2>&1
					iptables -A FORWARD -i br0 -j DROP > /dev/null 2>&1
				fi
			else
				ParentalControlTimer=`expr $ParentalControlTimer - 10`
			fi
		elif [ "$PAR_CON_ENABLED" = 2 ] && [ "$ParentalControlTimer" != 0 ]; then
			iptables -D FORWARD -i br0 -j PAR_CON > /dev/null 2>&1
			iptables -A FORWARD -i br0 -j PAR_CON > /dev/null 2>&1
		elif [ "$PAR_CON_ENABLED" = 3 ]; then
			if [ "$ParentalControlTimer" = 0 ]; then
				ParentalControlTimer=30
				ParentalControlCheck=`cat /proc/net/arp | grep -i $ParentalControlMAC`
				if [ "$ParentalControlCheck" ]; then
					iptables -D FORWARD -i br0 -j DROP > /dev/null 2>&1
					iptables -D FORWARD -i br0 -j PAR_CON > /dev/null 2>&1
					iptables -A FORWARD -i br0 -j PAR_CON > /dev/null 2>&1
					ping -c 1 `echo $ParentalControlCheck | cut -d " " -f 1` > /dev/null 2>&1 &
				else
					iptables -D FORWARD -i br0 -j PAR_CON > /dev/null 2>&1
					iptables -D FORWARD -i br0 -j DROP > /dev/null 2>&1
					iptables -A FORWARD -i br0 -j DROP > /dev/null 2>&1
				fi
			else
				ParentalControlTimer=`expr $ParentalControlTimer - 10`
			fi
		fi
	fi
	# End Parental Control
	if [ "$_PCI_THREEWAY_SWITCH_" = "y" ] && [ "$GREENAP_ENABLE" = 1 ] && [ "$WLAN_DISABLED" = 0 ] && [ ! -f /tmp/running_init ]; then
		SUN_DAY="`expr $GREENAP_WEEKDAYS % 2 / 1`"
		MON_DAY="`expr $GREENAP_WEEKDAYS % 4 / 2`"
		TUE_DAY="`expr $GREENAP_WEEKDAYS % 8 / 4`"
		WED_DAY="`expr $GREENAP_WEEKDAYS % 16 / 8`"
		THU_DAY="`expr $GREENAP_WEEKDAYS % 32 / 16`"
		FRI_DAY="`expr $GREENAP_WEEKDAYS % 64 / 32`"
		SAT_DAY="`expr $GREENAP_WEEKDAYS % 128 / 64`"
		ALL_DAY="`expr $GREENAP_WEEKDAYS % 256 / 128`"
		TIME_TYPE="$GREENAP_TIME_TYPE"
		START_HOUR="$GREENAP_START_HOUR"
		START_MINUTE="$GREENAP_START_MINUTE"
		STOP_HOUR="$GREENAP_STOP_HOUR"
		STOP_MINUTE="$GREENAP_STOP_MINUTE"
		WWW="`date +%w`"
		HHH="`date +%H`"
		MMM="`date +%M`"
		if [ "$ALL_DAY" = 1 ] ||
		[ "$WWW" -eq 0 -a "$SUN_DAY" -eq 1 ] ||
		[ "$WWW" -eq 1 -a "$MON_DAY" -eq 1 ] ||
		[ "$WWW" -eq 2 -a "$TUE_DAY" -eq 1 ] ||
		[ "$WWW" -eq 3 -a "$WED_DAY" -eq 1 ] ||
		[ "$WWW" -eq 4 -a "$THU_DAY" -eq 1 ] ||
		[ "$WWW" -eq 5 -a "$FRI_DAY" -eq 1 ] ||
		[ "$WWW" -eq 6 -a "$SAT_DAY" -eq 1 ]; then
			MATCH_DAY=1
		else
			MATCH_DAY=0
		fi
		if [ "$MATCH_DAY" = 1 ]; then
			if [ "$TIME_TYPE" = 0 ]; then
				MATCH_TIME=1
			else
				if [ "$HHH" -ge "$START_HOUR" ] && [ "$HHH" -le "$STOP_HOUR" ]; then
					if [ "$HHH" -eq "$START_HOUR" -a "$MMM" -lt "$START_MINUTE" ] || [ "$HHH" -eq "$STOP_HOUR" -a "$MMM" -gt "$STOP_MINUTE" ]; then
						MATCH_TIME=0
					else
						MATCH_TIME=1
					fi
				else
					MATCH_TIME=0
				fi
			fi
		fi
		wireless_is_upping="`ifconfig | grep ^wlan0[^-]`"
		if [ "$MATCH_DAY" = 1 ] && [ "$MATCH_TIME" = 1 ]; then
			if [ "$wireless_is_upping" = "" ]; then
				for i in "wlan0" "wlan0-va0" "wlan0-va1" "wlan0-va2" "wlan0-va3" "wlan0-vxd" "wlan0-wds0" "wlan0-wds1" "wlan0-wds2" "wlan0-wds3" "wlan0-wds4" "wlan0-wds5" "wlan0-wds6" "wlan0-wds7"; do
					if [ "`cat /tmp/interfaces_downed_by_greenap | grep ^$i$`" ]; then
						ifconfig $i up
					fi
				done
				echo 2 > /proc/wlan_led
				> /tmp/interfaces_downed_by_greenap
			fi
		else
			if [ "$wireless_is_upping" != "" ]; then
				> /tmp/interfaces_downed_by_greenap
				for i in "wlan0-wds7" "wlan0-wds6" "wlan0-wds5" "wlan0-wds4" "wlan0-wds3" "wlan0-wds2" "wlan0-wds1" "wlan0-wds0" "wlan0-vxd" "wlan0-va3" "wlan0-va2" "wlan0-va1" "wlan0-va0" "wlan0"; do
					if [ "`ifconfig $i | grep UP`" != "" ]; then
						echo $i >> /tmp/interfaces_downed_by_greenap
						ifconfig $i down
					fi
				done
				echo 3 > /proc/wlan_led
			fi
		fi
	fi
	if [ "$_USB_8712_" = "y" -a "$_MODE_" = "Hawking" ]; then
		WLANSTATUS=`wpa_cli -i wlan1 status |head -n 1|  cut -d "=" -f1`
		if [ "$WLANSTATUS" = "bssid" ]; then
			bssid=`wpa_cli -i wlan1 status |head -n 1|  cut -d "=" -f2`
		#	wpa_cli -p/var/run/wpa_supplicant scan 
		#	singal=`wpa_cli -p/var/run/wpa_supplicant scan_results |grep $bssid| cut -b 24-26`
			singal=`iwconfig wlan1 |grep Link | cut -d "=" -f3| cut -d / -f1`
		#	echo "$singal"
			if [ $singal -gt 66 ]; then
				echo 0 > /proc/wps_led
			elif [ $singal -gt 33 ]; then
				echo 1 > /proc/wps_led
			elif [ $singal -gt 0 ]; then  	
				echo 2 > /proc/wps_led
			else
				echo 3 > /proc/wps_led
			fi
		else
			echo 3 > /proc/wps_led
		fi
		if [ $RETRYTIME -gt 2 ]; then
			WLANSTATUS=`ifconfig wlan1 |grep inet`
			if [ "$WLANSTATUS" = "" -a "`pidof wps_wlan1.sh`" = "" ]; then
				wlan1.sh wlan1
			fi
			RETRYTIME=0
		else
			RETRYTIME=`expr $RETRYTIME + 1`
		fi
	fi
	if [ "$_INTERNET_STATE_" = "y" ]; then
		  ppp_connect_type="`flash get PPP_CONNECT_TYPE | cut -d '=' -f 2`"
		  pptp_connect_type="`flash get PPTP_CONNECT_TYPE | cut -d '=' -f 2`"
		  l2tp_connect_type="`flash get L2TP_CONNECT_TYPE | cut -d '=' -f 2`"
		if [ "$WAN_MODE" = "2"  -a  "$ppp_connect_type" = 1 ] || [ "$WAN_MODE" = "3" -a "$pptp_connect_type" = 1 ] || [ "$WAN_MODE" = "6"  -a "$l2tp_connect_type" = 1 ]; then 
		             echo 2 > /proc/internet_state
	        else 
			Result=0
			if [ "$Result" = 0 ] && [ "`fping 8.8.8.8 | grep alive | wc -l`" = 1 ]; then Result=1; fi # Google DNS
			if [ "$Result" = 0 ] && [ "`fping 8.8.4.4 | grep alive | wc -l`" = 1 ]; then Result=1; fi # Google DNS
			if [ "$Result" = 0 ] && [ "`fping 208.67.222.222 | grep alive | wc -l`" = 1 ]; then Result=1; fi # Open DNS
			if [ "$Result" = 0 ] && [ "`fping 208.67.220.220 | grep alive | wc -l`" = 1 ]; then Result=1; fi # Open DNS

			if [ "$Result" = 1 ]; then
			     echo 1 > /proc/internet_state
			else 
			     echo 2 > /proc/internet_state
			fi
	   fi
	    
   fi
  
	sleep $SLEEP_TIME
done
