#!/bin/sh
. /bin/scriptlib.sh
if [ "$#" != 3 ]; then
exit 1
fi
wanIP=$1
IP_ADDR=$2
SUBNET_MASK=$3
while [ 1 ]; do
lanIP="`cat /proc/dmz_by_port`"
if [ "$lanIP" ]; then
if [ "$lanIP" = "0.0.0.0" ]; then
old_lanIP=$lanIP
if [ -f "/tmp/un_dmz_by_port.sh" ]; then
/tmp/un_dmz_by_port.sh
rm -rf /tmp/un_dmz_by_port.sh
fi
elif [ "$old_lanIP" != "$lanIP" ]; then
old_lanIP=$lanIP
if [ -f "/tmp/un_dmz_by_port.sh" ]; then
/tmp/un_dmz_by_port.sh
rm -rf /tmp/un_dmz_by_port.sh
fi
iptables -t nat -D PREROUTING -i $_WAN_IF_ -p tcp --dport 80 -j DROP
iptables -t nat -D PREROUTING -i $_WAN_IF_ -p tcp --dport 80 -j DROP
iptables -A PREROUTING -t nat -p 47 -d $wanIP -j DNAT --to-destination 0.0.0.0
iptables -A PREROUTING -t nat -p all -d $wanIP -j DNAT --to $lanIP
iptables -A POSTROUTING -t nat -p ALL -s $IP_ADDR/$SUBNET_MASK -d $lanIP -j SNAT --to $IP_ADDR
echo "iptables -D PREROUTING -t nat -p 47 -d $wanIP -j DNAT --to-destination 0.0.0.0" > /tmp/un_dmz_by_port.sh
echo "iptables -D PREROUTING -t nat -p all -d $wanIP -j DNAT --to $lanIP" >> /tmp/un_dmz_by_port.sh
echo "iptables -D POSTROUTING -t nat -p ALL -s $IP_ADDR/$SUBNET_MASK -d $lanIP -j SNAT --to $IP_ADDR" >> /tmp/un_dmz_by_port.sh
echo "iptables -t nat -A PREROUTING -i $_WAN_IF_ -p tcp --dport 80 -j DROP" >> /tmp/un_dmz_by_port.sh
chmod 777 /tmp/un_dmz_by_port.sh
fi
fi
sleep 5
done