#!/bin/sh
. /bin/scriptlib.sh
. /web/FUNCTION_SCRIPT
if [ "$_EZVIEW_" = "" ] && [ "$_MODE_" != "Customer" -o "$_MODE_" != "Customer" ]; then
DNS_MODE=0
if [ "$DNS1" != '0.0.0.0' ] || [ "$DNS2" != '0.0.0.0' ] || [ "$DNS3" != '0.0.0.0' ]; then
DNS_MODE=1
fi
fi
if [ "$_MODE_" = "Customer" -o "$_MODE_" = "Customer" ] && [ "$WAN_MODE" = 1 ]; then
DNS_MODE=1
fi
DNS_TEMP=/tmp/dns.tmp
DNS_LOG=/var/log/dns.log
dnrd -k 2>/dev/null
rm $DNS_TEMP 2>/dev/null
rm $DNS_LOG 2>/dev/null
rm /var/run/dns-tmp 2>/dev/null
if [ "$DNS_MODE" = "1" ]; then
echo "<<< User define DNS >>>" >> $DNS_LOG
if [ ! "`cat /etc/resolv.conf`" ]; then
echo "nameserver 8.8.8.8" > /etc/resolv.conf
fi
if [ "$_PPTP_FQDN_" = "y" ] && [ "$WAN_MODE" = 3 -o "$WAN_MODE" = 6 ]; then
echo "DNS= `cat /etc/resolv.conf | grep "nameserver" | cut -f 2 -d" " | head -n 1`" >> $DNS_LOG
echo -n " -s `cat /etc/resolv.conf | grep "nameserver" | cut -f 2 -d" " | head -n 1`" >> $DNS_TEMP
fi
echo "DNS1= $DNS1" >> $DNS_LOG
echo "DNS2= $DNS2" >> $DNS_LOG
echo "DNS3= $DNS3" >> $DNS_LOG
if [ "$DNS1" != '0.0.0.0' ]; then
echo -n " -s $DNS1" >> $DNS_TEMP
fi
if [ "$DNS2" != '0.0.0.0' ]; then
echo -n " -s $DNS2" >> $DNS_TEMP
fi
if [ "$DNS3" != '0.0.0.0' ]; then
echo -n " -s $DNS3" >> $DNS_TEMP
fi
if [ "$DNS1" = '0.0.0.0' ] && [ "$DNS2" = '0.0.0.0' ] && [ "$DNS3" = '0.0.0.0' ]; then
echo -n " -s 8.8.8.8" >> $DNS_TEMP
fi
if [ -f "$DNS_TEMP" ]; then
DNRD_COMMAND=`cat $DNS_TEMP`
else
DNRD_COMMAND=""
fi
echo "Use command: $DNRD_COMMAND" >> $DNS_LOG
if [ "$_MODEL_" = "BR6428GN" ] && [ "$_MODE_" = "Customer" ]; then
: # 因為軟測說只要有手動 DNS 就不能跑 DNRD，要用 udhcpd 發給底下的 client
else
if [ "$DNRD_COMMAND" != "" ]; then
dnrd -c off $DNRD_COMMAND
fi
fi
else
echo "<<< Auto setting DNS >>>" >> $DNS_LOG
if [ "$_TRIPPPOE_" = "y" ]; then
if [ -f /etc/ppp/link2 ]; then
cat /etc/resolv2.conf | grep "nameserver" | cut -f 2 -d" " > /var/dns-temp2
line=`cat /var/dns-temp2 | wc -l`
num=1
while [ $num -le $line ]; do
pat=` head -n $num /var/dns-temp2 | tail -n 1`
pat="$pat:mopera.net"
echo -n " --server=$pat" >> /var/dnrd-tmp
echo "$pat" >> /var/run/dns-tmp
num=`expr $num + 1`
done
fi
fi
if [ "$_MPPPOE_" = "y" ]; then
if [ -f /etc/ppp/link1 ]; then
cat /etc/resolv1.conf | grep "nameserver" | cut -f 2 -d" " > /var/dns-temp1
line=`cat /var/dns-temp1 | wc -l`
num=1
while [ $num -le $line ]; do
pat=` head -n $num /var/dns-temp1 | tail -n 1`
if [ "$num" = 1 ]; then
pat="$pat:flets"
else
pat="$pat:194.210.220.in-addr.arpa"
fi
echo -n " --server=$pat" >> /var/dnrd-tmp
echo "$pat" >> /var/run/dns-tmp
num=`expr $num + 1`
done
fi
fi
cat /etc/resolv.conf | grep "nameserver" | cut -f 2 -d" " > /var/dns-temp
line=`cat /var/dns-temp | wc -l`
num=1
while [ $num -le $line ]; do
pat=` head -n $num /var/dns-temp | tail -n 1`
if [ "$line" -ge 2 ]; then
if [ "$_MPPPOE_" = "y" ] || [ "$_TRIPPPOE_" = "y" ]; then
if [ -f /etc/ppp/link1 ] || [ -f /etc/ppp/link2 ]; then
if [ "$num" = 1 ]; then
pat="$pat:com"
fi
fi
fi
fi
echo -n " --server=$pat" >> /var/dnrd-tmp
echo "$pat" >> /var/run/dns-tmp
num=`expr $num + 1`
done
echo "" >> /var/run/dns-tmp
echo "" >> /var/dnrd-tmp
pat=`head -n 1 /var/dnrd-tmp | tail -n 1`
echo "Use command: $pat" >> $DNS_LOG
if [ ! "`cat /var/dns-temp`" ]; then
echo "nameserver 8.8.8.8" > /etc/resolv.conf
pat="-s 8.8.8.8"
fi
master=""
if [ "$_Customer_" = "y" ] || [ "$_MODE_" = "Customer" -a "$_MODEL_" = "BR6228GNS" ]; then
master="-m /etc/hosts"
fi
if [ "`cat /var/dns-temp`" ] && [ "$pat" != "" ]; then
dnrd -c off $pat $master
else
dnrd -c off -s 8.8.8.8 $master
fi
rm /var/dns-temp*
rm /var/dnrd-tmp
fi
if [ "$_WanAutoDetect_" = "y" ]; then
AUTODETECT_DISABLE="`flash get AUTODETECT_DISABLE | cut -d '=' -f 2`"
if [ "$AUTODETECT_DISABLE" = 0 ]; then
ppp_connect_type="`flash get PPP_CONNECT_TYPE | cut -d '=' -f 2`"
pptp_connect_type="`flash get PPTP_CONNECT_TYPE | cut -d '=' -f 2`"
l2tp_connect_type="`flash get L2TP_CONNECT_TYPE | cut -d '=' -f 2`"
if [ "$ppp_connect_type" = 0 ] && [ "$pptp_connect_type" = 0 ] && [ "$l2tp_connect_type" = 0 ]; then
ksigusr2=`cat /tmp/wanStatus`
if [ "$ksigusr2" != "1" ]; then
kill -SIGUSR2 `pidof dnrd`
fi
fi
fi
fi
if [ "$_IQSETUP_" = "y" -a "$IQSETUP_DISABLE" = 0 ] || [ "$_QUICK_MODE_TYPE_" = "y" ]; then
scriptlib_util.sh iQsetup_ping
ksigusr2=`cat /tmp/wanStatus`
if [ "$ksigusr2" != "1" ]; then
kill -SIGUSR2 `pidof dnrd`
fi
fi
