#!/bin/sh

. ../../define/PATH
PATH=${CROSSDIR}:$PATH

if [ $# = 1 ]; then
	case "$1" in
		"configure")
			MAKECONFIGURE=1
			MAKECLEAR=1
			MAKING=0
			;;
		"clean")
			MAKECONFIGURE=0
			MAKECLEAR=1
			MAKING=0
			;;
		"make")
			MAKECONFIGURE=1
			MAKECLEAR=1
			MAKING=1
			;;
	esac
fi

if [ $MAKECLEAR = 1 ]; then
	make clean
fi

if [ $MAKECONFIGURE = 1 ]; then
	CC=${CROSS_COMPILE}gcc CXX=${CROSS_COMPILE}g++ ./configure --host=mips-linux
fi

if [ $MAKING = 1 ]; then
	make
	${CROSS_COMPILE}strip src/updatedd
	${CROSS_COMPILE}strip src/plugins/.libs/libnoip.so.0.0.0
fi