#!/bin/sh
. /bin/scriptlib.sh
echo "-----> DDNS"
if [ "$DDNS_ENABLED" != "1" ] ; then
echo "DDNS not ENABLE"         
exit 0
fi                                                                 
DDNS_CONFFILE=/var/ddns.conf
DDNS_BIN=/bin/ez-ipupdate
DHIS_CONFFILE=/var/dhid.conf
DHIS_BIN=/bin/dhid
WAN=$_WAN_IF_
if [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6258GNL" ]; then
WLAN_IF2=wlan0-vxd
elif [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6258NL" ]; then
WLAN_IF2=wlan0-vxd
else
WLAN_IF2=wlan0
fi
case "$WAN_MODE" in
"0")
if [ "$OP_MODE" = "1" ];then
if [ "$_USB_8712_" = "y" ]; then
WAN=wlan1
else
WAN=$WLAN_IF2
fi
else
WAN=$_WAN_IF_
fi
;;
"1")
if [ "$OP_MODE" = "1" ];then
if [ "$_USB_8712_" = "y" ]; then
WAN=wlan1
else
WAN=$WLAN_IF2
fi
else
WAN=$_WAN_IF_
fi
;;
"2")
WAN=ppp0
;;
"3")
WAN=ppp0
;;
"6")
WAN=ppp0
;;
esac
WAN_IP0=`ifconfig $WAN | grep -i "addr:" | grep -v grep`
WAN_IP1=`echo $WAN_IP0 | cut -f2 -d:`
WAN_IP=`echo $WAN_IP1 | cut -f1 -d " "`
killall dhid 2> /dev/null
if [ "$DDNS_PVID_SEL" = "dhis" ] || [ "$DDNS_PVID_SEL" = "aiaimamor" ]; then
echo "create $DHIS_CONFFILE..."
rm -f $DHIS_CONFFILE 2> /dev/null
echo "{" > $DHIS_CONFFILE
echo "HostID $DHIS_HOSTID" >> $DHIS_CONFFILE
if [ "$DHIS_SELECT" = "0" ]; then
echo "HostPass $DHIS_PASSWORD" >> $DHIS_CONFFILE
else
echo "AuthP $DHIS_AUTH_P1" >> $DHIS_CONFFILE
echo "AuthP $DHIS_AUTH_P2" >> $DHIS_CONFFILE
echo "AuthQ $DHIS_AUTH_Q1" >> $DHIS_CONFFILE
echo "AuthQ $DHIS_AUTH_Q2" >> $DHIS_CONFFILE
fi
echo "ISAddr $DHIS_ISADDR" >> $DHIS_CONFFILE
echo "OnCmd /bin/dhid-online.sh" >> $DHIS_CONFFILE
echo "OffCmd /bin/dhid-offline.sh" >> $DHIS_CONFFILE
echo "}" >> $DHIS_CONFFILE
echo "run $DHIS_BIN..."
$DHIS_BIN
elif [ "$DDNS_PVID_SEL" = "noip" ]; then
noip2 -C -u $DDNS_ACCOUNT -p $DDNS_PASS -I 30 -U 30 -Y -c $DDNS_CONFFILE
noip2 -c $DDNS_CONFFILE -i $WAN_IP
else
echo "create $DDNS_CONFFILE..."
rm -f $DDNS_CONFFILE 2> /dev/null
echo "service-type=$DDNS_PVID_SEL" > $DDNS_CONFFILE
echo "user=$DDNS_ACCOUNT:$DDNS_PASS" >> $DDNS_CONFFILE
echo "host=$DDNS_NAME" >> $DDNS_CONFFILE
if [ "$_DDNS_REFRESH_INTERVAL_" != "" ]; then
echo "daemon" >> $DDNS_CONFFILE
echo "period=$_DDNS_REFRESH_INTERVAL_" >> $DDNS_CONFFILE
echo "interface=$WAN" >> $DDNS_CONFFILE
killall -QUIT ez-ipupdate
fi
echo "run $DDNS_BIN..."
$DDNS_BIN -c $DDNS_CONFFILE -a $WAN_IP
fi
