#!/bin/sh
if [ $# -lt 2 ]; then echo "Usage: $0 interface {wait|no]";  exit 1 ; fi
. /bin/scriptlib.sh
SCRIPT_PATH=/etc/udhcpc
PIDFILE=/var/udhcpc/udhcpc-$1.pid
CMD="-i $1 -p $PIDFILE -s $SCRIPT_PATH/$1.sh"
. /web/FUNCTION_SCRIPT
if [ "$2" = 'no' ]; then
CMD="$CMD -n"
echo "#!/bin/sh" > $SCRIPT_PATH/$1.deconfig
echo "ifconfig $1 $IP_ADDR netmask $SUBNET_MASK" >> $SCRIPT_PATH/$1.deconfig
echo "while route del -net default gw 0.0.0.0 dev $1" >> $SCRIPT_PATH/$1.deconfig
echo "do :" >> $SCRIPT_PATH/$1.deconfig >> $SCRIPT_PATH/$1.deconfig
echo "done" >> $SCRIPT_PATH/$1.deconfig >> $SCRIPT_PATH/$1.deconfig
echo "route add -net default gw $DEFAULT_GATEWAY dev $1" >> $SCRIPT_PATH/$1.deconfig
echo "init.sh ap wlan_app" >> $SCRIPTFILE_PATH/$1.deconfig	#Erwin
else
echo "#!/bin/sh" > $SCRIPT_PATH/$1.deconfig
echo "echo into $1.deconfig" >> $SCRIPT_PATH/$1.deconfig
fi
chmod +x $SCRIPT_PATH/$1.deconfig
kill -9 `pidof udhcpc` 2> /dev/null
if [ "$DYNIP_HOSTNAME" != "" ]; then
CMD="$CMD -h $DYNIP_HOSTNAME"
fi
udhcpc $CMD