#!/bin/sh
. /bin/scriptlib.sh
if [ -f /tmp/uninstall_vlan.sh ]; then
chmod 777 /tmp/uninstall_vlan.sh
/tmp/uninstall_vlan.sh
rm /tmp/uninstall_vlan.sh
fi
Set_Bridge_and_VLAN ( )
{
if [ "$2" != "0" ]; then
ifconfig ra`expr "$2" - 1` up
fi
if [ "$1" != "0" ] && [ "$2" != "0" ]; then
if [ "$_VLAN_AP_" = "y" ]; then
brctl addbr br$1
vconfig add eth2 $1
brctl addif br$1 eth2.$1
brctl delif br0 ra`expr "$2" - 1`
brctl addif br$1 ra`expr "$2" - 1`
ifconfig br$1 up
ifconfig eth2.$1 up
echo "ifconfig br"$1" down" >> /tmp/uninstall_vlan.sh
echo "brctl delbr br"$1 >> /tmp/uninstall_vlan.sh
echo "vconfig rem eth2."$1 >> /tmp/uninstall_vlan.sh
else
brctl addbr br$1
vconfig add br0 $1
brctl addif br$1 br0.$1
brctl delif br0 ra`expr "$2" - 1`
brctl addif br$1 ra`expr "$2" - 1`
ifconfig br$1 up
ifconfig br0.$1 up
echo "ifconfig br"$1" down" >> /tmp/uninstall_vlan.sh
echo "brctl delbr br"$1 >> /tmp/uninstall_vlan.sh
echo "vconfig rem br0."$1 >> /tmp/uninstall_vlan.sh
fi
else
brctl addif br0 ra`expr "$2" - 1`
fi
}
if [ "$_ENVLAN_" = "y" ]; then
Set_Bridge_and_VLAN $VLANID_1 $SSID_MIRROR_1
Set_Bridge_and_VLAN $VLANID_2 $SSID_MIRROR_2
Set_Bridge_and_VLAN $VLANID_3 $SSID_MIRROR_3
Set_Bridge_and_VLAN $VLANID_4 $SSID_MIRROR_4
Set_Bridge_and_VLAN $VLANID_5 $SSID_MIRROR_5
Set_Bridge_and_VLAN $VLANID_6 $SSID_MIRROR_6
else
Set_Bridge_and_VLAN 0 $SSID_MIRROR_1
Set_Bridge_and_VLAN 0 $SSID_MIRROR_2
Set_Bridge_and_VLAN 0 $SSID_MIRROR_3
Set_Bridge_and_VLAN 0 $SSID_MIRROR_4
Set_Bridge_and_VLAN 0 $SSID_MIRROR_5
Set_Bridge_and_VLAN 0 $SSID_MIRROR_6
fi
