#!/bin/sh
. /bin/scriptlib.sh
if [ "$_EZVIEW_" = "" ] && [ "$_MODE_" != "Customer" ]; then
DNS_MODE=0
if [ "$DNS1" != '0.0.0.0' ] || [ "$DNS2" != '0.0.0.0' ] || [ "$DNS3" != '0.0.0.0' ]; then
DNS_MODE=1
fi
fi
if [ "$DNS_MODE" = 1 ]; then
> /etc/resolv.conf
if [ "$DNS1" != '0.0.0.0' ]; then
echo "nameserver $DNS1" >> /etc/resolv.conf
fi
if [ "$DNS2" != '0.0.0.0' ]; then
echo "nameserver $DNS2" >> /etc/resolv.conf
fi
if [ "$DNS3" != '0.0.0.0' ]; then
echo "nameserver $DNS3" >> /etc/resolv.conf
fi
fi
if [ "$1" = "dhcpc" ]; then
killall rdisc 2> /dev/null
rdisc -s &
rdisc -f
if [ "$_WAN_DHCP_AUTO_RELEASED_" = "y" ]; then
echo "start" > /var/dhcpCheck.var
fi
elif [ "$1" = "static" ]; then
if [ "$_MODE_" = "Customer" ] || [ "$_MODE_" = "Customer" ]; then
> /etc/resolv.conf
if [ "$DNS1" != '0.0.0.0' ]; then
echo "nameserver $DNS1" >> /etc/resolv.conf
fi
if [ "$DNS2" != '0.0.0.0' ]; then
echo "nameserver $DNS2" >> /etc/resolv.conf
fi
if [ "$DNS3" != '0.0.0.0' ]; then
echo "nameserver $DNS3" >> /etc/resolv.conf
fi
else
if [ $DNS_MODE != 1 ]; then
echo "nameserver 8.8.8.8" > /etc/resolv.conf
fi
fi
else
if [ "$_MODE_" = "Customer" ] && [ "$WAN_MODE" = 3 -o "$WAN_MODE" = 6 ]; then # Customer PPTP/L2TP 連線成功後要留下 Dynamic/Static 前兩組的 DNS
cat /etc/resolv.conf > /tmp/resolv.conf.tmp
fi
if [ "$WAN_MODE" = 3 ] && [ ! -f /etc/ppp/resolv.conf ]; then
if [ "$PPTP_IPMODE" = 1 ]; then
echo "nameserver 8.8.8.8" > /etc/resolv.conf
fi
elif [ "$WAN_MODE" = 6 ] && [ ! -f /etc/ppp/resolv.conf ]; then
if [ "$L2TP_IPMODE" = 1 ]; then
echo "nameserver 8.8.8.8" > /etc/resolv.conf
fi
fi
LOOP=2
while [ $LOOP -ge 1 ]; do
eval FILERESOLV=/etc/ppp/resolv$LOOP.conf
if [ -f $FILERESOLV ]; then
cat $FILERESOLV > /etc/resolv$LOOP.conf
fi
LOOP=`expr $LOOP - 1`
done
if [ "$_MODE_" = "Customer" ] || [ "$_MODE_" = "Customer" ]; then
if [ "$DNS_MODE" = 0 ]; then
if [ -f /etc/ppp/resolv.conf ]; then
cat /etc/ppp/resolv.conf > /etc/resolv.conf
fi
elif [ "$DNS1" = "0.0.0.0" ] && [ "$DNS2" = "0.0.0.0" ] && [ "$DNS3" = "0.0.0.0" ]; then
echo "nameserver 8.8.8.8" > /etc/resolv.conf
fi
else
if [ -f /etc/ppp/resolv.conf ]; then
cat /etc/ppp/resolv.conf > /etc/resolv.conf
fi
fi
if [ "$_MODE_" = "Customer" ] && [ "$WAN_MODE" = 3 -o "$WAN_MODE" = 6 ]; then # Customer PPTP/L2TP 連線成功後要留下 Dynamic/Static 前兩組的 DNS
cat /etc/resolv.conf >> /tmp/resolv.conf.tmp
cat /tmp/resolv.conf.tmp > /etc/resolv.conf
rm /tmp/resolv.conf.tmp
fi
if [ "$_SDMZ_" = "y" ]; then
if [ "$DMZ_MODE" = 1 ] && [ "$DMZ_ENABLED" = 1 ]; then
ifconfig ppp0 mtu $PPP_MTU
fi
fi
fi
if [ "$_MODE_" = "Customer" ] && [ "$WAN_MODE" = 0 ] && [ "$DEFAULT_GATEWAY" != "0.0.0.0" ]; then
while route del default 2>/dev/null
do :
done
route add default gw $DEFAULT_GATEWAY
fi
dnrd -k 2>/dev/null
if [ "`pidof dnrd`" = "" -a "$DNS_MODE" = 0 ]; then   
dnrd.sh
fi
echo "********** set Time Zone **********"
if [ "$_TIME_ZONE_TYPE_" = "y" ]; then
if [ "$TIME_TYPE" = "0" ];then
/bin/sntp.sh &
fi
else
/bin/sntp.sh &
fi
sleep 1
echo "********** run firewall.sh **********"
firewall.sh
if [ "$_INTERNET_STATE_" = "y" ]; then
echo 0 > /proc/internet_led
fi
if [ "$_EZVIEW_" = "y" ]; then
ez
fi
if [ "$_IPV6_SUPPORT_" = "y" ] && [ "$IPV6_WAN_MODE" != 8 ]; then
ipv6.sh
ipv6_firewall.sh
fi
