#!/bin/sh
. /web/FUNCTION_SCRIPT
. /bin/scriptlib.sh
GETMIB="flash get"
SET_WLAN="iwpriv $1"
SET_WLAN_PARAM="$SET_WLAN set_mib"
IFCONFIG=ifconfig
case "$2" in
"setssid")
i=0
while [ $i -lt $_MSSIDNUM_ ]; do
if [ "$1" = "wlan0-va$i" ]; then
eval `$GETMIB SSID_\`expr $i + 1\``
eval "tmpSSID=\$SSID_`expr $i + 1`"
$SET_WLAN_PARAM ssid="$tmpSSID"
fi
i=`expr $i + 1`
done
;;
"hiddenssid")
i=0
while [ $i -lt $_MSSIDNUM_ ]; do
if [ "$1" = "wlan0-va$i" ]; then
eval `$GETMIB HIDDEN_SSID_\`expr $i + 1\``
eval "tmpHIDDENSSID=\$HIDDEN_SSID_`expr $i + 1`"
$SET_WLAN_PARAM hiddenAP=$tmpHIDDENSSID
fi
i=`expr $i + 1`
done
if [ "$_MODE_" != "Customer" ]; then
$SET_WLAN_PARAM dtimperiod=$DTIM_PERIOD
fi
;;
"setAccessWMM")
i=0
while [ $i -lt $_MSSIDNUM_ ]; do
if [ "$1" = "wlan0-va$i" ]; then
eval `$GETMIB WLAN_ACCESS_\`expr $i + 1\``
eval "tmpWMM=\$WLAN_ACCESS_`expr $i + 1`"
$SET_WLAN_PARAM guest_access=$tmpWMM
eval `$GETMIB WLAN_WMM_\`expr $i + 1\``
eval "tmpWMM=\$WLAN_WMM_`expr $i + 1`"
$SET_WLAN_PARAM qos_enable=$tmpWMM
fi
i=`expr $i + 1`
done
;;
"setMSSIDwep")
if [ "$1" = "wlan0-va0" ] || [ "$1" = "wlan0-va1" ] || [ "$1" = "wlan0-va2" ] || [ "$1" = "wlan0-va3" ] || [ "$1" = "wlan0-va4" ]; then
lastNum=`echo $1 | cut -b 9-9`
NU=`expr $lastNum + 1`
WLANVAP_ENCRYPT=`flash get WLAN_ENCRYPT_$NU | cut -d '=' -f 2`
if [ "$WLANVAP_ENCRYPT" = '0' ]; then	#0:disable 1:WEP 2:WPA-preshare 3WPA RADIUAS
$SET_WLAN_PARAM encmode=0
elif [ "$WLANVAP_ENCRYPT" = '1' ]; then
WEP_VAP=`flash get WEP_$NU | cut -d '=' -f 2`
WEP64_VAP_KEY1=`flash get WEP64_KEY1_$NU | cut -d '=' -f 2`
WEP64_VAP_KEY2=`flash get WEP64_KEY2_$NU | cut -d '=' -f 2`
WEP64_VAP_KEY3=`flash get WEP64_KEY3_$NU | cut -d '=' -f 2`
WEP64_VAP_KEY4=`flash get WEP64_KEY4_$NU | cut -d '=' -f 2`
WEP128_VAP_KEY1=`flash get WEP128_KEY1_$NU | cut -d '=' -f 2`
WEP128_VAP_KEY2=`flash get WEP128_KEY2_$NU | cut -d '=' -f 2`
WEP128_VAP_KEY3=`flash get WEP128_KEY3_$NU | cut -d '=' -f 2`
WEP128_VAP_KEY4=`flash get WEP128_KEY4_$NU | cut -d '=' -f 2`
WEP_DEFAULT_VAP_KEY=`flash get WEP_DEFAULT_KEY_$NU | cut -d '=' -f 2`
if [ "$WEP_VAP" = '1' ]; then	# 1 is 64 bit
$SET_WLAN_PARAM encmode=1
$SET_WLAN_PARAM wepkey1=$WEP64_VAP_KEY1
$SET_WLAN_PARAM wepkey2=$WEP64_VAP_KEY2
$SET_WLAN_PARAM wepkey3=$WEP64_VAP_KEY3
$SET_WLAN_PARAM wepkey4=$WEP64_VAP_KEY4
$SET_WLAN_PARAM wepdkeyid=$WEP_DEFAULT_VAP_KEY
else	# 2 is 128 bit
$SET_WLAN_PARAM encmode=5
$SET_WLAN_PARAM wepkey1=$WEP128_VAP_KEY1
$SET_WLAN_PARAM wepkey2=$WEP128_VAP_KEY2
$SET_WLAN_PARAM wepkey3=$WEP128_VAP_KEY3
$SET_WLAN_PARAM wepkey4=$WEP128_VAP_KEY4
$SET_WLAN_PARAM wepdkeyid=$WEP_DEFAULT_VAP_KEY
fi
else
$SET_WLAN_PARAM encmode=2
fi
fi #end for $1 = wlan0-va0 .....
;;
"setMSSIDwpa")
if [ "$1" = "wlan0-va0" ] || [ "$1" = "wlan0-va1" ] || [ "$1" = "wlan0-va2" ] || [ "$1" = "wlan0-va3" ] || [ "$1" = "wlan0-va4" ]; then
eval `$GETMIB WLAN_WPA_AUTH`
lastNum=`echo $1 | cut -b 9-9`
NU=`expr $lastNum + 1`
WLANVAP_ENCRYPT=`flash get WLAN_ENCRYPT_$NU | cut -d '=' -f 2`
WLAN_WPA_AUTH=`flash get WLAN_WPA_AUTH_$NU | cut -d '=' -f 2`
if [ $AP_MODE != 1 ] && [ $WLANVAP_ENCRYPT -ge 2 ] && [ $WLAN_WPA_AUTH = 2 ]; then
if [ $WLANVAP_ENCRYPT = 2 ]; then
ENABLE=1
elif [ $WLANVAP_ENCRYPT = 4 ]; then
ENABLE=2
elif [ $WLANVAP_ENCRYPT = 6 ]; then
ENABLE=3
else
echo "invalid ENCRYPT value!"; exit
fi
$SET_WLAN_PARAM psk_enable=$ENABLE
if [ $WLANVAP_ENCRYPT = 2 ] || [ $WLANVAP_ENCRYPT = 6 ]; then
WLANVAP_WPA_CIPHER_SUITE=`flash get WLAN_WPA_CIPHER_SUITE_$NU | cut -d '=' -f 2`
if [ $WLANVAP_WPA_CIPHER_SUITE = 1 ]; then
CIPHER=2
elif [ $WLANVAP_WPA_CIPHER_SUITE = 2 ]; then
CIPHER=8
elif [ $WLANVAP_WPA_CIPHER_SUITE = 3 ]; then
CIPHER=10
else
echo "invalid WPA_CIPHER_SUITE value!"; exit 1
fi
fi
$SET_WLAN_PARAM wpa_cipher=$CIPHER
if [ $WLANVAP_ENCRYPT = 4 ] || [ $WLANVAP_ENCRYPT = 6 ]; then
WLANVAP_WPA2_CIPHER_SUITE=`flash get WPA2_CIPHER_SUITE_$NU | cut -d '=' -f 2`
if [ $WLANVAP_WPA2_CIPHER_SUITE = 1 ]; then
CIPHER=2
elif [ $WLANVAP_WPA2_CIPHER_SUITE = 2 ]; then
CIPHER=8
elif [ $WLANVAP_WPA2_CIPHER_SUITE = 3 ]; then
CIPHER=10
else
echo "invalid WPA2_CIPHER_SUITE value!"; exit 1
fi
fi
$SET_WLAN_PARAM wpa2_cipher=$CIPHER
VAP_WPA_PSK=`flash get WLAN_WPA_PSK_$NU | cut -d '=' -f 2 | cut -d "'" -f 2`
$SET_WLAN_PARAM passphrase="$VAP_WPA_PSK"
eval `$GETMIB WLAN_WPA_GROUP_REKEY_TIME`
$SET_WLAN_PARAM gk_rekey=$WLAN_WPA_GROUP_REKEY_TIME
else
$SET_WLAN_PARAM psk_enable=0
fi
fi
;;
"setWirelessClientLimit")
i=0
while [ $i -lt $_MSSIDNUM_ ]; do
if [ "$1" = "wlan0-va$i" ]; then
eval `$GETMIB WIRELESSCLIENTLIMIT\`expr $i + 1\``
eval "LIMIT=\$WIRELESSCLIENTLIMIT`expr $i + 1`"
$SET_WLAN_PARAM stanum=$LIMIT
fi
i=`expr $i + 1`
done
;;
esac
