#!/bin/sh
. /bin/scriptlib.sh
WAN=$_WAN_IF_
LAN=br0
RIPD_CONF=/var/ripd.conf
kill `cat /var/run/ripd.pid 2>/dev/null` 2>/dev/null
if [ "$RIP_ENABLED" = "1" ]; then
if [ "$OP_MODE" = '1' ]; then
WAN=br1
fi
if [ "$WAN_MODE" = "2" ]; then
WAN=ppp0
fi
if [ "$WAN_MODE" = "3" ]; then
WAN=ppp0
fi
if [ "$WAN_MODE" = "6" ]; then
WAN=ppp0
fi
echo '' >  $RIPD_CONF
echo "hostname ripd" >> $RIPD_CONF
echo "interface $WAN " >> $RIPD_CONF
if [ "$_Customer_THREEWAY_SWITCH_" = "y" ]; then
if [ "$NAT_ENABLE" = "0" ]; then
if [ "$RIP_SEND" != "0" ]; then
echo "ip rip send version $RIP_SEND " >> $RIPD_CONF
fi
fi
if [ "$RIP_RECV" != "0" ]; then
echo "ip rip receive version $RIP_RECV " >> $RIPD_CONF
fi
else
echo "ip rip send version 1 2 " >> $RIPD_CONF
echo "ip rip receive version 1 2 " >> $RIPD_CONF
fi
echo "interface $LAN " >> $RIPD_CONF
if [ "$_Customer_THREEWAY_SWITCH_" = "y" ]; then
if [ "$NAT_ENABLE" = "0" ]; then
if [ "$RIP_SEND_LAN" != "0" ]; then
echo "ip rip send version $RIP_SEND_LAN " >> $RIPD_CONF
fi
if [ "$RIP_RECV_LAN" != "0" ]; then
echo "ip rip receive version $RIP_RECV_LAN " >> $RIPD_CONF
fi
fi
else
echo "ip rip send version 1 2 " >> $RIPD_CONF
echo "ip rip receive version 1 2 " >> $RIPD_CONF
fi
echo "router rip " >> $RIPD_CONF
echo "network $WAN " >> $RIPD_CONF
if [ "$_Customer_THREEWAY_SWITCH_" = "y" ]; then
echo "no passive-interface $WAN " >> $RIPD_CONF
else
echo "passive-interface $WAN " >> $RIPD_CONF
fi
echo "network $LAN" >> $RIPD_CONF
echo "no passive-interface $LAN" >> $RIPD_CONF
ripd -f $RIPD_CONF -d
fi
