#!/bin/sh
. /bin/scriptlib.sh
LOG_FILE=/var/log/syslog
if [ "$#" = "1" ] ; then
if [ "$1" = "clean" ]; then
killall syslogd 2> /dev/null
rm -f $LOG_FILE 2> /dev/null
if [ "$_SUPPORT_REMOTE_SYSLOGD_" = "y" ]; then
enable="`flash get REMOTE_SYSLOGD_ENABLE | cut -f 2 -d =`"
if [ "$enable" = "1" ]; then
ip="`flash get REMOTE_SYSLOGD_SERVERIP | cut -f 2 -d \'`"
if [ "$ip" ] && [ "$ip" != "0.0.0.0" ]; then
syslogd -C -L -R $ip
fi
else
syslogd -C
fi
else
syslogd -C
fi
fi
fi
logread > $LOG_FILE
