#!/bin/sh  
. /web/FUNCTION_SCRIPT
. /bin/scriptlib.sh
if [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6258GNL" ]; then
SET_WLAN_PARAM="iwpriv wlan0-vxd set_mib"
elif [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6258NL" ]; then
SET_WLAN_PARAM="iwpriv wlan0-vxd set_mib"
else
SET_WLAN_PARAM="iwpriv wlan0 set_mib"
fi
LESS_THEN_TWO()
{
temp=$1
if [ ${#temp} -lt 2 ]; then
temp=0$temp
else
temp=$temp
fi
echo $temp
}
TX_POWER_ADD()
{
replacestr=""
FLAG_VALUE=$1
ADD_VALUE=$2
i=1
temp=`echo $FLAG_VALUE | cut -c 1-4` 
if [ "$temp" != "0000"  ];then 
temp=""
while [ $i -lt ${#FLAG_VALUE} ];
do
k=`expr $i + 1`
temp=`echo $FLAG_VALUE | cut -c $i-$k`
temp="`hex_dec_convert hex2dec $temp`"
if [ "$_TX_POWER_CONTROL_" = "y" ]; then
temp=`expr $temp + $ADD_VALUE`
else
temp=`expr $temp - $ADD_VALUE`
fi
temp=`hex_dec_convert dec2hex $temp`
replacestr=$replacestr"`LESS_THEN_TWO $temp`"
i=`expr $i + 2`
done
fi
echo $replacestr
}
TX_POWER_MINUS()
{
replacestr=""
FLAG_VALUE=$1
MINUS_VALUE=$2
i=1
temp=`echo $FLAG_VALUE | cut -c 1-4` 
if [ "$temp" != "0000"  ];then 
temp=""
while [ $i -lt ${#FLAG_VALUE} ];
do
k=`expr $i + 1`
temp=`echo $FLAG_VALUE | cut -c $i-$k`
temp="`hex_dec_convert hex2dec $temp`"
if [ $temp -gt $MINUS_VALUE ]; then
temp=`expr $temp - $MINUS_VALUE`
else
temp=01
fi
temp=`hex_dec_convert dec2hex $temp`
replacestr=$replacestr"`LESS_THEN_TWO $temp`"
i=`expr $i + 2`
done
fi
echo $replacestr
}
if [ "$_ENABLE_POWER_TABLE_" = "y" ]; then
echo "==> Set Tx power high level"
if [ "$HW_PWTBL_ENABLE" = "0" ]; then
if [ "$_MODEL_" = "BR6428HPN" ]; then
Value11b=2
Value11g=4
Value11n20M=4
Value11n40M=4
else
Value11b=0
Value11g=0
Value11n20M=0
Value11n40M=0
fi
else	
if [ "$HW_11N_RESERVED9" = "1" -o "$HW_11N_RESERVED9" = "2" ]; then
if [ $HW_PWTBL_B -ge 16 ]; then
B_BAND=`hex_dec_convert dec2hex $HW_PWTBL_B | cut -c 1`
else
B_BAND=0
fi
if [ $HW_PWTBL_G -ge 16 ]; then
G_BAND=`hex_dec_convert dec2hex $HW_PWTBL_G | cut -c 1`
else
G_BAND=0
fi
if [ $HW_PWTBL_N_20M -ge 16 ]; then
N_BAND_20M=`hex_dec_convert dec2hex $HW_PWTBL_N_20M | cut -c 1`
else
N_BAND_20M=0
fi
if [ $HW_PWTBL_N_40M -ge 16 ]; then
N_BAND_40M=`hex_dec_convert dec2hex $HW_PWTBL_N_40M | cut -c 1`
else
N_BAND_40M=0
fi
else
if [ $HW_PWTBL_B -ge 16 ]; then
B_BAND=`hex_dec_convert dec2hex $HW_PWTBL_B | cut -c 2`
else
B_BAND=`hex_dec_convert dec2hex $HW_PWTBL_B | cut -c 1`
fi
if [ $HW_PWTBL_G -ge 16 ]; then
G_BAND=`hex_dec_convert dec2hex $HW_PWTBL_G | cut -c 2`
else
G_BAND=`hex_dec_convert dec2hex $HW_PWTBL_G | cut -c 1`
fi
if [ $HW_PWTBL_N_20M -ge 16 ]; then
N_BAND_20M=`hex_dec_convert dec2hex $HW_PWTBL_N_20M | cut -c 2`
else
N_BAND_20M=`hex_dec_convert dec2hex $HW_PWTBL_N_20M | cut -c 1`
fi
if [ $HW_PWTBL_N_40M -ge 16 ]; then
N_BAND_40M=`hex_dec_convert dec2hex $HW_PWTBL_N_40M | cut -c 2`
else
N_BAND_40M=`hex_dec_convert dec2hex $HW_PWTBL_N_40M | cut -c 1`
fi
fi
Value11b=`hex_dec_convert hex2dec $B_BAND`
Value11g=`hex_dec_convert hex2dec $G_BAND`
Value11n20M=`hex_dec_convert hex2dec $N_BAND_20M`
Value11n40M=`hex_dec_convert hex2dec $N_BAND_40M`
fi
$SET_WLAN_PARAM txPowerPlus_cck_1=$Value11b
$SET_WLAN_PARAM txPowerPlus_cck_2=`expr $Value11b \* 2 / 3  `
$SET_WLAN_PARAM txPowerPlus_cck_5=`expr $Value11b \* 1 / 3 `
$SET_WLAN_PARAM txPowerPlus_cck_11=0
$SET_WLAN_PARAM txPowerPlus_ofdm_6=$Value11g
$SET_WLAN_PARAM txPowerPlus_ofdm_9=`expr $Value11g \* 6 / 7`
$SET_WLAN_PARAM txPowerPlus_ofdm_12=`expr $Value11g \* 5 / 7`
$SET_WLAN_PARAM txPowerPlus_ofdm_18=`expr $Value11g \* 4 / 7`
$SET_WLAN_PARAM txPowerPlus_ofdm_24=`expr $Value11g \* 3 / 7`
$SET_WLAN_PARAM txPowerPlus_ofdm_36=`expr $Value11g \* 2 / 7`
$SET_WLAN_PARAM txPowerPlus_ofdm_48=`expr $Value11g \* 1 / 7`
$SET_WLAN_PARAM txPowerPlus_ofdm_54=0
if [ "$WLAN_N_CHAN_WIDTH" = "1" ]; then  #20M
$SET_WLAN_PARAM txPowerPlus_mcs_0=$Value11n20M
$SET_WLAN_PARAM txPowerPlus_mcs_1=`expr $Value11n20M \* 6 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_2=`expr $Value11n20M \* 5 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_3=`expr $Value11n20M \* 4 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_4=`expr $Value11n20M \* 3 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_5=`expr $Value11n20M \* 2 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_6=`expr $Value11n20M \* 1 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_7=0
$SET_WLAN_PARAM txPowerPlus_mcs_8=$Value11n20M
$SET_WLAN_PARAM txPowerPlus_mcs_9=`expr $Value11n20M \* 6 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_10=`expr $Value11n20M \* 5 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_11=`expr $Value11n20M \* 4 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_12=`expr $Value11n20M \* 3 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_13=`expr $Value11n20M \* 2 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_14=`expr $Value11n20M \* 1 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_15=0
else #40M
$SET_WLAN_PARAM txPowerPlus_mcs_0=$Value11n40M
$SET_WLAN_PARAM txPowerPlus_mcs_1=`expr $Value11n40M \* 6 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_2=`expr $Value11n40M \* 5 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_3=`expr $Value11n40M \* 4 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_4=`expr $Value11n40M \* 3 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_5=`expr $Value11n40M \* 2 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_6=`expr $Value11n40M \* 1 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_7=0
$SET_WLAN_PARAM txPowerPlus_mcs_8=$Value11n40M
$SET_WLAN_PARAM txPowerPlus_mcs_9=`expr $Value11n40M \* 6 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_10=`expr $Value11n40M \* 5 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_11=`expr $Value11n40M \* 4 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_12=`expr $Value11n40M \* 3 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_13=`expr $Value11n40M \* 2 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_14=`expr $Value11n40M \* 1 / 7`
$SET_WLAN_PARAM txPowerPlus_mcs_15=0
fi
fi
if [ 1 = 1 ]; then
echo "set TX Power:" $WLAN_TX_POWER
if [ "$_ENABLE_POWER_TABLE_" = "y" ]; then
if [ "$HW_REG_DOMAIN" = "1"  ]; then
A1=$WLAN_TX_POWER
B1=$WLAN_TX_POWER
C1=$WLAN_TX_POWER
else
if [ "$HW_11N_RESERVED9" = "1" ]; then
A1=`expr $WLAN_TX_POWER + 7`
B1=`expr $WLAN_TX_POWER + 8`
C1=`expr $WLAN_TX_POWER + 5`
elif [ "$HW_11N_RESERVED9" = "0" ]; then
A1=`expr $WLAN_TX_POWER + 15`
B1=`expr $WLAN_TX_POWER + 16`
C1=`expr $WLAN_TX_POWER + 10`
else
A1=$WLAN_TX_POWER
B1=$WLAN_TX_POWER
C1=$WLAN_TX_POWER
fi
fi
else #For Airlive BR6228GN BR6428GN
A1=$WLAN_TX_POWER
B1=$WLAN_TX_POWER
C1=$WLAN_TX_POWER
fi
echo "A1: $A1 B1: $B1 C1: $C1 txpower.sh"
replacestr="`TX_POWER_MINUS $HW_TX_POWER_CCK_A $A1`"
$SET_WLAN_PARAM pwrlevelCCK_A=$replacestr
replacestr="`TX_POWER_MINUS $HW_TX_POWER_HT40_1S_A $C1`"
$SET_WLAN_PARAM pwrlevelHT40_1S_A=$replacestr
if [ "$_RFTYPE_" = "2T2R" ]; then
replacestr="`TX_POWER_MINUS $HW_TX_POWER_CCK_B $B1`"
$SET_WLAN_PARAM pwrlevelCCK_B=$replacestr
replacestr="`TX_POWER_MINUS $HW_TX_POWER_HT40_1S_B $C1`"
$SET_WLAN_PARAM pwrlevelHT40_1S_B=$replacestr
fi
fi
