#!/bin/sh
. /bin/scriptlib.sh
echo "-----> UPNP"
getCurrentWANIP
IGD_PID_FILE=/var/run/miniupnpd.pid
killall -15 miniigd 2> /dev/null
if [ -f "$IGD_PID_FILE" ]; then
rm -f $IGD_PID_FILE
fi
if [ "$1" = "disable" ]; then
UPNP_ENABLE=0
route del -net 239.255.255.250 netmask 255.255.255.255 br0 2>/dev/null
fi
if [ $UPNP_ENABLE = 1 ]; then 
route del -net 239.255.255.250 netmask 255.255.255.255 br0 2>/dev/null
route add -net 239.255.255.250 netmask 255.255.255.255 br0
iptables -t filter -N MINIUPNPD	
iptables -A FORWARD -i $CURRENT_WAN -j MINIUPNPD
iptables -t nat -N MINIUPNPD	
iptables -t nat -A PREROUTING -i $CURRENT_WAN -d $CURRENT_WAN_IP -j MINIUPNPD
if [ "$OP_MODE" = '1' ];then
if [ "$_USB_8712_" = "y" ]; then 
miniigd -e $WAN_DHCP -i br0  -w wlan1
else
miniigd -e $WAN_DHCP -i br0  -w wlan0
fi
else
miniigd -e $WAN_DHCP -i br0
fi
_CMD=
if [ $WPS_ENABLE = 1 ]; then
_CMD="$_CMD -wsc /tmp/wscd_config"
fi
_CMD="$_CMD -igd /tmp/igd_config"
killall -9 mini_upnpd 2> /dev/null
mini_upnpd $_CMD &
fi
