#!/bin/sh
. /bin/scriptlib.sh
PROB_RESULET=""
PROB_RETURN_FILE=/var/wanprob.var
if [ "$_MODE_" = "Customer" -o "$_MODE_" = "Customer" -o "$_MODE_" = "Customer" ] && [ `linkdetect.sh 4 | cut -d "=" -f 2` = 0 ]; then
i=1
while [ `linkdetect.sh 4 | cut -d "=" -f 2` = 0 ]; do
sleep 1
if [ $i -eq 4 ]; then
echo "WANTYPE=\"NOLINK\"" > $PROB_RETURN_FILE
exit
fi
i=`expr $i + 1`
done
fi
if [ "$_Customer_WAN_PROB_" = "y" ]; then	# Realtek does not have "mii_mgr" to use
PORT=1
fi
if [ "$AP_ROUTER_SWITCH" = "1" ]; then
echo "WANTYPE=\"AP\"" > $PROB_RETURN_FILE
exit
fi
echo "##############################"
echo "# Disable All Wan connection #"
echo "##############################"
disconnect.sh all
killall udhcpc
sleep 1
echo "##############################"
echo "#       Prob  DHCP           #"
echo "##############################"
PROB_RESULET="` udhcpc -n -i $_WAN_IF_ | grep -i obtained | grep -v gre`"
killall udhcpc 2> /dev/null
if [ "$PROB_RESULET" != "" ]; then
IPADDR="`echo $PROB_RESULET | grep -i obtained | grep -v gre | cut -d\" \" -f 3`"
IPADDR_ONE="`echo $IPADDR | cut -d. -f 1`"
IPADDR_TWO="`echo $IPADDR | cut -d. -f 2`"
if [ "$IPADDR_ONE" = "192" ] && [ "$IPADDR_TWO" = "168" ]; then
echo "WAN Type=PRIVATE DHCP mode."
echo "WANTYPE=\"PRIVATE\"" > $PROB_RETURN_FILE
exit
elif [ "$IPADDR_ONE" = "172" ] && [ "$IPADDR_TWO" = "16" ]; then
echo "WAN Type=PRIVATE DHCP mode."
echo "WANTYPE=\"PRIVATE\"" > $PROB_RETURN_FILE
exit
elif [ "$IPADDR_ONE" = "10" ]; then
echo "WAN Type=PRIVATE DHCP mode."
echo "WANTYPE=\"PRIVATE\"" > $PROB_RETURN_FILE
exit
else
echo "WAN Type=DHCP mode."
fi
/bin/flash set DNS1 0.0.0.0
/bin/flash set DNS2 0.0.0.0
/bin/flash set DNS3 0.0.0.0
echo "WANTYPE=\"DHCP\"" > $PROB_RETURN_FILE
echo "Prob finish!"
exit
fi
echo "##############################"
echo "#       Prob PPPoE           #"
echo "##############################"
PROB_RESULET="`pppoe -d -I $_WAN_IF_`"
if [ "$PROB_RESULET" != "" ]; then
echo "WAN Type=PPPOE."
echo "Prob finish!"
echo "WANTYPE=\"PPPOE\"" > $PROB_RETURN_FILE
/bin/flash set DNS1 0.0.0.0
/bin/flash set DNS2 0.0.0.0
/bin/flash set DNS3 0.0.0.0
exit
fi
if [ "$_Customer_WAN_PROB_" = "y" ]; then
if [ "$PORT" = "0" ]; then
if [ "$TRIPPPOE" = "y" ]; then
echo "4" > /tmp/wanStatus    #wan無連接狀態
fi
echo "WANTYPE=\"NOLINK\"" > $PROB_RETURN_FILE
else
echo "WANTYPE=\"STATIC\"" > $PROB_RETURN_FILE
fi
else
echo "WANTYPE=\"STATIC\"" > $PROB_RETURN_FILE
fi
