#!/bin/sh
. /bin/scriptlib.sh
WAN=$_WAN_IF_
LAN=br0
ZEBRA_CONF=/var/zebra.conf
kill `cat /var/run/zebra.pid 2>/dev/null` 2>/dev/null
if [ "$RIP_ENABLED" = "0" ] ; then
exit
fi
if [ "$OP_MODE" = '1' ];then
WAN=br1
fi
if [ "$WAN_MODE" = "2" ]; then
WAN=ppp0
fi
if [ "$WAN_MODE" = "3" ]; then
WAN=ppp0
fi
if [ "$WAN_MODE" = "6" ]; then
WAN=ppp0
fi
echo '' >  $ZEBRA_CONF
echo "hostname Router" >> $ZEBRA_CONF
echo "interface $WAN" >> $ZEBRA_CONF
echo "multicast" >> $ZEBRA_CONF
echo "interface $LAN" >> $ZEBRA_CONF
echo "multicast" >> $ZEBRA_CONF
echo "password @zebra" >> $ZEBRA_CONF
if [ "$RIP_ENABLED" = "1" ]; then
zebra -f $ZEBRA_CONF -d
fi
